/******************************************************************************
    Program search.cgi, search thru database to match word(s):
    - main.c - source file for initialize search program

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "config.h"
#include "main.h"
#include "search.h"

void getword(char *word, char *line, char stop);/* extract words from line */
void unescape_url(char *url);/* Checks url */
void plustospace(char *str);/* Converts '+' sign to ' ' sign */
int loadconf(char *FNAME,char *HelP,char *BodY,char *ErroR,char *HeaD,char *HTmlC);/* load config file */
void writefile(char *SomeFile,char *CopyRight);/* write some html file */
void writeerror(char *ErrorFile,char *CopyRight,int NoMessage);/* write error */
void search(int SeC,short int IspiS);/* search section and write rezults */
void get_word(char *words);/* get word value under words list */
void IgnoreCase(unsigned char *BLin);

/*------------------------------ Main program ----------------------------*/
int main(void) 
{
typedef struct {/* structure for line arguments */
 char name[128];/* name ov item */
 char val[512]; /* value of named item (128) */
} entry;/* name of structure */
entry entries[1000];/* set number of input entry from input line */
register int x,m=0;
char *cl,HelpH[512],BodyH[512],ErrorH[512],HeadH[512],lin[1024];
char HtmlC[255];
int Wand=0,Wor=0,Wnot=0;
FILE *f;

SCounT=1;CounT=10;/* initialize counters */
printf("Content-type: text/html%c%c",10,10); /* initialize html output */
if(strcmp(getenv("REQUEST_METHOD"),"GET")) { /* test input method */
  printf("This script should be referenced with a METHOD of GET.\n");
  printf("If you don't understand this, see this ");
  printf("<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c",10);
  exit(1);}/* end if no input, writed error */

/* Loading default configuration values from search.h file */
strcpy(HelpH,HELP_HTML);/* set default location for help.html file */
strcpy(BodyH,BODY_HTML);/* set default location for body.html file */
strcpy(ErrorH,ERROR_HTML);/* set default location for error.html file */
strcpy(HeadH,HEAD_HTML);/* set default location for head.html file */
strcpy(HtmlC,HTML_COPYRIGHT);/* set default bottom copyright info */
strcpy(RezCol,REZULTCOLOR);/* set default color in writing rezults */
TypPage=ALLPAGES;/* set limit of writing rezults */
REPLACE[0]=0;/* set default location for replace url file (default none) */

/* Updating values from config file if exists in conf file */
if (loadconf(CONF_FILE,HelpH,BodyH,ErrorH,HeadH,HtmlC)) exit(1);

/* check if there is replace file */
if (REPLACE[0]!=0) {/* file exists */
 if( (f=fopen(REPLACE,"r"))==NULL ){/* check replace file for reading */
  printf("<!-- Can't load replace file: %s -->\n",REPLACE);REPLACE[0]=0;
 }else fclose(f);}/* file ok */

cl = getenv("PATH_INFO");/* scan for help request */
if(cl != NULL) {/* Help wanted, write help page */
 if(strncmp(cl,"/ver",4)==0)/* write version status */
  printf("Search.cgi v0.1.7 Copyright by Silvio Klaic 1997-2000.\n");
 else writefile(HelpH,HtmlC);exit(0);}/* end of help */

cl = getenv("QUERY_STRING");/* scan for input request */
if(cl == NULL) { /* No input was given write error */
  printf("No query information to decode.\n");
  exit(1);}/* end of if input */

for(x=0;cl[0]!=0;x++) { /* Process input parametars */
   m=x;
   getword(entries[x].val,cl,'&');/* extract words from input line */
   plustospace(entries[x].val);/* convert '+' to ' ' */
   unescape_url(entries[x].val);/* eplace '%' in url line */
   getword(entries[x].name,entries[x].val,'=');/* put words to structure */
}/* end for x */

if(strlen(entries[0].name) == 0) {/* There is no input parametars */
  writefile(BodyH,HtmlC);/* write body.html like first page */
  exit(0);}/* end if no input */

for(x=0;x<=m;x++){/* check items and find values */
   if( strcmp(entries[x].name,"search")==0 )
     get_word(entries[x].val);/* get word value under search item */
   if( strcmp(entries[x].name,"count")==0 )
     CounT=atoi(entries[x].val);/* value under display no results */
   if( strcmp(entries[x].name,"SecT")==0 )
     section[atoi(entries[x].val)].stat=1;/* set selected sections */
   if( strcmp(entries[x].name,"type")==0 )
     TypCase=atoi(entries[x].val);/* value under type of search method */
   if( strcmp(entries[x].name,"FsecT")==0 )
     section[atoi(entries[x].val)].stat=2;/* set first section */
   if( strcmp(entries[x].name,"SCounT")==0 )
     SCounT=atoi(entries[x].val);/* set count of displayed messages */
}/* end for x in testing input names and values */

if(CUR_WORD==-1){/* There are no valid words for search */
  writeerror(ErrorH,HtmlC,100);/* write error.html and error */
  exit(1);}/* end if no words */

for(x=1;(section[x].stat==0)&&(x<CUR_SECT);x++);/* test number of section */
if( (x==CUR_SECT)&&(section[x].stat==0) ){/* There's no section */
 writeerror(ErrorH,HtmlC,101);/* write error.html and error */
 exit(1);}/* end if no section */

for(x=0;x<=CUR_WORD;x++){/* go thru words to determine search status */
 if( (WordS[x].stat[1]==1)||(WordS[x].stat[1]==4) )Wor++;/* count "or" words */
 if( (WordS[x].stat[1]==0)||(WordS[x].stat[1]==3) )Wand++;/* count "and" words*/
 if( (WordS[x].stat[1]==-1)||(WordS[x].stat[1]==2) )Wnot++;/*count "not" words*/
}/* end for x thru words */

if( (Wnot!=0)&&(Wor==0)&&(Wand==0) ){/* there is only not words can't search */
 writeerror(ErrorH,HtmlC,102);/* write error.html and error */
 exit(1);}/* end if only not words */

/* open head.html to display rezults and do search */
printf("<!-- Search.cgi v%s Copyright by Silvio Klaic 1997-2000.  -->\n",\
	VERSION);/* write signature and copyright */

if( (f=fopen(HeadH,"r"))==NULL ){/* open head.html file for reading */
 printf("Can't read %s !<BR>\n",HeadH);/* can't open file, write error */
 exit(0);}/* end if not open */

while(!feof(f)){/* go thru file and write it */
 lin[0]=0;fgets(lin,1024,f);/* reset line and get line */
 if(strncmp(lin,"<!-- Title, DON'T REMOVE OR CHANGE THIS COMMENT!!!  -->",55)==0 ){/* found place for title */
  printf("Search rezults for:\n");
  for(x=0;x<CUR_WORD;x++)/* write words for search */
   printf(" %s,",WordS[x].word);
  printf(" %s\n",WordS[CUR_WORD].word);/* write last word */
 }else/* end of writing title */
  if(strncmp(lin,"<!-- Search rezults, DON'T REMOVE OR CHANGE THIS COMMENT!!!  -->",64)==0){/* found place for search rezults */
   printf("<FONT SIZE=2>Requested word\n");
   if(CUR_WORD>1) printf("s");
   for(x=0;x<=CUR_WORD;x++){/* Write selected words */
    if(!TypCase)/* it's ignore case do convert */
     IgnoreCase(WordS[x].sign);
    switch (WordS[x].stat[1]) {/* found type of words */
     case 0:/* and words */
      printf(" : &quot;<I>%s</I>&quot;\n",WordS[x].word);break;
     case -1:/* not words */
      printf(" : &quot;<U>%s</U>&quot;\n",WordS[x].word);break;
     case 1:/* or words */
      printf(" : &quot;<B>%s</B>&quot;\n",WordS[x].word);break;
     case 2:/* not words + substring */
      switch (WordS[x].stat[2]) {/* found type of substring */
       case -1:printf(" : *&quot;<U>%s</U>&quot;\n",WordS[x].word);break;
       case 0:printf(" : *&quot;<U>%s</U>&quot;*\n",WordS[x].word);break;
       case 1:printf(" : &quot;<U>%s</U>&quot;*\n",WordS[x].word);break;
      }break;/* end switch thru type of substring */
     case 3:/* and words + substring */
      switch (WordS[x].stat[2]) {/* found type of substring */
       case -1:printf(" : *&quot;<I>%s</I>&quot;\n",WordS[x].word);break;
       case 0:printf(" : *&quot;<I>%s</I>&quot;*\n",WordS[x].word);break;
       case 1:printf(" : &quot;<I>%s</I>&quot;*\n",WordS[x].word);break;
      }break;/* end switch thru type of substring */
     case 4:/* or words + substring */
      switch (WordS[x].stat[2]) {/* found type of substring */
       case -1:printf(" : *&quot;<B>%s</B>&quot;\n",WordS[x].word);break;
       case 0:printf(" : *&quot;<B>%s</B>&quot;*\n",WordS[x].word);break;
       case 1:printf(" : &quot;<B>%s</B>&quot;*\n",WordS[x].word);break;
      }break;/* end switch thru type of substring */
     default:/* something wrong */
      printf(" : <B>Error unknown type: [%s] - %d</B><BR>\n",WordS[x].word,\
		      WordS[x].stat[1]);break;
    }/* end of switch thru words */
   }/* end for x */
   printf("<BR></FONT>\n");
   for(x=CUR_SECT;(x>=1)&&(section[x].stat!=2);x--);/* scan first section */
   if(x==0){/* no first section marked first used */
    for(x=1;(x<=CUR_SECT)&&(section[x].stat==0);x++);/* find used */
    section[x].stat=2;/* select first for using */
   }/* end if x */
   search(x,true);/* search and display rezults */
  }else/* end of writing first search rezults */
   if(strncmp(lin,"<!-- Other sections, DON'T REMOVE OR CHANGE THIS COMMENT!!!  -->",64)==0){/* found place for display others section */
    for(x=1;x<=CUR_SECT;x++)/* go thru all selected sections */
     if(section[x].stat==1)/* use only other sections */
      search(x,false);/* search and display brief form */
   }else/* end of writing other sections */
    printf("%s",lin);/* write file */
}/* end while eof */
fclose(f);/* close file */
printf("<FONT SIZE=2><HR SIZE=4 WIDTH=\"70%%\" ALIGN=LEFT>\n%s\n</FONT>\n",\
 HtmlC);fflush(NULL);/*write copyright for generating this html file (visible)*/
return(0);
}/* end of main() */
