/******************************************************************************
    Program search.cgi, search thru database to match word(s):
    - util.c - source file for util functions in cgi program

    Copyright (C) 1997-2000 Silvio Klaic, sklaic@student.math.hr
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "extern.h"

/**************** Get words from cgi input line *********************/
void getword(char *word, char *line, char stop)
{
int x,y;

for(x=0;((line[x])&&(line[x]!=stop));x++)/* go thru line */
 word[x] = line[x];/* copy characters until "stop" character */
word[x]=0;/* complete word */
if(line[x]) ++x;
y=0;
while( (line[y++]=line[x++]) );/* cut copyed word from line */
}

/*********************** converts hex number to char *********************/
char x2c(char *what) 
{
register char digit;

digit=(what[0]>='A' ?((what[0] & 0xdf)-'A')+10 : (what[0]-'0'));
digit*=16;
digit+=(what[1]>='A' ?((what[1] & 0xdf)-'A')+10 : (what[1]-'0'));
return(digit);
}

/****************** Checks url for html special sign and replace it ********/
void unescape_url(char *url) 
{
register int x,y;

for(x=0,y=0;url[y];++x,++y) {
 if((url[x]=url[y])=='%') {
  url[x]=x2c(&url[y+1]);
  y+=2;
 }/* end if url */
}/* end for x */
url[x]=0;/* complete url line */
}

/************************* Converts '+' sign to ' ' sign **********************/
void plustospace(char *str) 
{
register int x;

for(x=0;str[x];x++) if(str[x] == '+') str[x] = ' ';
}

/************************* Converts ' ' sign to '+' sign **********************/
void spacetoplus(unsigned char *str)
{
int x;

for(x=0;str[x];x++){/* go thru string */
 switch (str[x]){/* scan characters */
  case 32: printf("+");break;/* " " */
  case 33: printf("%%21");break;/* "!" */
  case 34: printf("%%5C%%22");break;/* """ */
  case 35: printf("%%23");break;/* "#" */
  case 36: printf("%%24");break;/* "$" */
  case 37: printf("%%25");break;/* "%" */
  case 38: printf("%%26");break;/* "&" */
  case 39: printf("%%27");break;/* "'" */
  case 40: printf("%%28");break;/* "(" */
  case 41: printf("%%29");break;/* ")" */
  case 43: printf("%%2B");break;/* "+" */
  case 44: printf("%%2C");break;/* "," */
  case 47: printf("%%2F");break;/* "/" */
  case 58: printf("%%3A");break;/* ":" */
  case 59: printf("%%3B");break;/* ";" */
  case 60: printf("%%3C");break;/* "<" */
  case 61: printf("%%3D");break;/* "=" */
  case 62: printf("%%3E");break;/* ">" */
  case 63: printf("%%3F");break;/* "?" */
  case 64: printf("%%40");break;/* "@" */
  case 91: printf("%%5B");break;/* "[" */
  case 92: printf("%%5C%%5C");break;/* "\" */
  case 93: printf("%%5D");break;/* "]" */
  case 94: printf("%%5E");break;/* "^" */
  case 96: printf("%%60");break;/* "`" */
  case 123: printf("%%7B");break;/* "{" */
  case 124: printf("%%7C");break;/* "|" */
  case 125: printf("%%7D");break;/* "}" */
  case 126: printf("%%7E");break;/* "~" */
  default: printf("%c",str[x]);break;
 }/* end switch */
}/* end for x */
}

/************************** make signature from letters ***********************/
int getletters(char *Ulin,char *Icode)
{
int i,j,dec[8],Size;
short int svi[96];

Size=0;
for(i=0;i<=96;i++) svi[i]=false;/* reset counters */
for(i=0;i<strlen(Ulin);i++)/* go thru line */
 if((Ulin[i]>32)&&(Ulin[i]<127)&&(Size==0)) svi[Ulin[i]-32]=true;/* select ch */
 else if( (Ulin[i]==32)&&(Size==0) ) Size=i;/* set word with space */
dec[7]=1;dec[6]=2;dec[5]=4;dec[4]=8;dec[3]=16;/* set decimal numbers */
dec[2]=32;dec[1]=64;dec[0]=128;/* set decimal numbers */
for(i=0;i<12;i++){/* go thru numbers */
 Icode[i]=0;
 for(j=i*8;j<i*8+8;j++)/* go thru string */
  if(svi[j]) Icode[i]+=dec[j-i*8];
/* set to character code */
}/* end for i */
/* mark eos, last number is on place 11 */
if(Size==0) Size=strlen(Ulin);/* not word with space return full size */
return(Size);/* return size of word */
}/* end getletters() */

/************************** extract number of words ***********************/
unsigned short int NOWord(char *Uword)
{
int i;
unsigned short int j=0;

for(i=0;i<strlen(Uword);i++)/* go thru line */
 if( (Uword[i]==32)&&(i!=0) ) j++;/* set word with space */
return(j+1);
}/* end NOWord() */
